#ifndef __config_h
#define __config_h
#include "platform.h"

// - - - - - - - - - - - - - - - - - - - - 
// pic_serial defines
// - - - - - - - - - - - - - - - - - - - - 

#define SERIAL_TX_BUFFER_SIZE 20
#define SERIAL_RX_BUFFER_SIZE 4

// Use this define if you want fine-grained control of what happens in the serial port
//#define SERIAL_DEBUG_ON

// Use this define if you are debugging in the IDE simulator and don't want it to hang
// waiting for serial interrupts that will never come...
//#define SERIAL_IDE_DEBUG

// Use thie define if you want to drop a character if the TX buffer is full,
// rather than the default behaviour, which is to wait until the TX buffer has
// a spare spot.
//#define SERIAL_DISCARD_ON_TX_FULL_DURING_INT

// - - - - - - - - - - - - - - - - - - - - 
// pic_term defines
// - - - - - - - - - - - - - - - - - - - - 

#define TERM_BUFFER_SIZE	10
// Reset (go to bootloader) if magic character received
#define TERM_ALLOW_BOOSTBLOADER
// Echo typing so user can see what they're doing
#define TERM_ECHO_INPUT

// - - - - - - - - - - - - - - - - - - - - 

// Create term_entry_callback in your own code
// void term_entry_callback(uns8 *term_buffer);

// - - - - - - - - - - - - - - - - - - - - 
// ccld defines
// - - - - - - - - - - - - - - - - - - - - 
	
#define ccld_sin_port PORTB
#define ccld_sin_pin	 4

#define ccld_clk_port PORTB
#define ccld_clk_pin	 3

#define ccld_blk_port PORTB
#define ccld_blk_pin	 2

#define ccld_lat_port PORTB
#define ccld_lat_pin	 1


//

#define DSP_0401B_TOTAL_CHARS 12

// - - - - - - - - - - - - - - -
// General platform definitions
// - - - - - - - - - - - - - - -
#define PLATFORM_TYPE EA_PLT_1002
#define PLATFORM_CLOCK 64000000


#endif