#ifndef __config_h
#define __config_h
#include "platform.h"

// - - - - - - - - - - - - - - - - - - - - 
// ITS mode1 defines
// - - - - - - - - - - - - - - - - - - - - 

#define ITS_EA { 0, 0, 0, 0, 0, 0, 0, 2 } 
#define CONTROLLER_EA { 0, 0, 0, 0, 0, 0, 0, 1 }
//#define ITS_MODE1_CONTROLLER
#define ITS_MODE1_DEVICE

// - - - - - - - - - - - - - - - - - - - - 
// its common defines
// - - - - - - - - - - - - - - - - - - - - 

#define ITS_MAX_KNOWN_DEVICES 5


// - - - - - - - - - - - - - - - - - - - - 
// pic_serial defines
// - - - - - - - - - - - - - - - - - - - - 

#define SERIAL_TX_BUFFER_SIZE 16
#define SERIAL_RX_BUFFER_SIZE 4
//#define SERIAL_DEBUG_ON

// - - - - - - - - - - - - - - - - - - - - 
// spi_hw defines
// - - - - - - - - - - - - - - - - - - - - 

#define SPI_HW_MASTER_MODE
// or
//#define SPI_HW_SLAVE_MODE

// In master mode, we need to define clock
//#define SPI_HW_MASTER_CLOCK_TMR2_DIV_2
//#define SPI_HW_MASTER_CLOCK_FOSC_DIV_64
#define SPI_HW_MASTER_CLOCK_FOSC_DIV_16
//#define SPI_HW_MASTER_CLOCK_FOSC_DIV_4

// mrf24j40

// interrupt (input)
#define mrf24j40_int_port PORTB
#define mrf24j40_int_pin  0

// Chip Select (output, active low)
#define mrf24j40_cs_port PORTA
#define mrf24j40_cs_pin  2

// Reset (output, active low, weak pull-up)
#define mrf24j40_reset_port PORTA
#define mrf24j40_reset_pin  3

// Wake (output, disabled by default)
#define mrf24j40_wake_port PORTA
#define mrf24j40_wake_pin  4

// ------------
// ITS Wireless
// ------------

#define ITS_USE_MRF24J50
#define ITS_MODE_1
//#define ITS_MODE_2
//#define ITS_DEVICE_TYPE ITS_M1_MASTER
#define ITS_DEVICE_TYPE ITS_M1_SLAVE
#define ITS_EXTENDED_ADDRESS {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01}
#define ITS_NETWORK_ID 0xa1a2
#define ITS_DEVICE_ID  0xb001
#define ITS_MAX_KNOWN_DEVICES	5
#define ITS_FIXED_CHANNEL	15

// - - - - - - - - - - - - - - -
// General platform definitions
// - - - - - - - - - - - - - - -
#define PLATFORM_TYPE OLIMEX_BOARD
#define PLATFORM_CLOCK 20000000


#endif