/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com
*/

/** \file drv_sure_3208.c
    \brief Draw drivers for HT1632 based displays such as Sure 3208 and similar


*/
#ifndef __draw_drv_sure_2416_h
#define __draw_drv_sure_2416_h

#include "ht1632.h"
#include "draw\draw.h"
#include "draw\draw_screen_buffer.h"

void drv_paint() {

uns8 count;
uns8 x, y, inv_y;
uns16 buffer_loc;
uns8 byte_loc, bit_loc;
uns8 data;

	//ht1632_send_command(HT1632_CMD_SYS_DISABLE);
	clear_pin(ht1632_cs1_port, ht1632_cs1_pin);
	
	// send WR command

	// send 1
	set_pin  (ht1632_data_port, ht1632_data_pin);
	// pulse wr
	clear_pin(ht1632_wr_port, ht1632_wr_pin);
	set_pin  (ht1632_wr_port, ht1632_wr_pin);
	
	// send 0
	clear_pin  (ht1632_data_port, ht1632_data_pin);
	// pulse wr
	clear_pin(ht1632_wr_port, ht1632_wr_pin);
	set_pin  (ht1632_wr_port, ht1632_wr_pin);

	// send 1
	set_pin  (ht1632_data_port, ht1632_data_pin);
	// pulse wr
	clear_pin(ht1632_wr_port, ht1632_wr_pin);
	set_pin  (ht1632_wr_port, ht1632_wr_pin);

	// send mem address of zero
	clear_pin(ht1632_data_port, ht1632_data_pin);
	
	// write mem addr, bits 6 -> 0
	for(count = 0 ; count < 7 ; count++) {
			
		//change_pin_var(ht1632_data_port, ht1632_data_pin, test_bit(mem_addr, 6));
		// pulse wr
		clear_pin(ht1632_wr_port, ht1632_wr_pin);
		set_pin  (ht1632_wr_port, ht1632_wr_pin);
		// shift mem addr along

	}
/*
	for(x = 0 ; x < DRAW_PIXELS_WIDE  ; x++) {
		for(y = 0 ; y < DRAW_PIXELS_HIGH ; y++) {
			inv_y = DRAW_PIXELS_HIGH - 1 - y;
			buffer_loc = inv_y * DRAW_PIXELS_WIDE + x;
			byte_loc = buffer_loc / DRAW_PIXELS_PER_BYTE;
			bit_loc = buffer_loc & (DRAW_PIXELS_PER_BYTE -1);
			if (test_bit(draw_buffer0[byte_loc], bit_loc)) {
				set_pin(ht1632_data_port, ht1632_data_pin);
			} else {
				clear_pin(ht1632_data_port, ht1632_data_pin);
			}	
			clear_pin(ht1632_wr_port, ht1632_wr_pin);
			set_pin  (ht1632_wr_port, ht1632_wr_pin);
		}
	}
*/	
	buffer_loc = 0;
	for (count = 0; count < 32; count++) {
		data = draw_buffer0[count];
		for (bit_loc = 0; bit_loc < 8; bit_loc++) {
			if (data.0) {
				set_pin(ht1632_data_port, ht1632_data_pin);
			} else {
				clear_pin(ht1632_data_port, ht1632_data_pin);
			}
			data = data >> 1;	
			clear_pin(ht1632_wr_port, ht1632_wr_pin);
			set_pin  (ht1632_wr_port, ht1632_wr_pin);
		}	
	}	

	/*uns8 xbyte = 0x2d;
	uns8 xbit = 0b00000001;
	
	for(x = 0 ; x < DRAW_PIXELS_WIDE  ; x++) {
		for(y = 0 ; y < 16 ; y++) {
		if (draw_buffer0[xbyte] & xbit) {
				set_pin(ht1632_data_port, ht1632_data_pin);
			} else {
				clear_pin(ht1632_data_port, ht1632_data_pin);
			}	
			clear_pin(ht1632_wr_port, ht1632_wr_pin);
			set_pin  (ht1632_wr_port, ht1632_wr_pin);
			if (xbyte < 3) {
				if (xbit == 0b10000000) {
					xbyte = xbyte + 0x2e;
					xbit = 0b00000001;
				} else {
					xbit = xbit << 1;
					xbyte = xbyte + 0x2d;
				}
			} else {		
				xbyte = xbyte - 3;
			}	
		}
	}
*/	// reset CS

	set_pin(ht1632_cs1_port, ht1632_cs1_pin);
	//ht1632_send_command(HT1632_CMD_SYS_ENABLE);

	
}	


uns8 drv_get_pixel(uns8 x, uns8 y) {
	//ht1632_get_pixel(x, y);
}

void drv_clear_screen() {
	//ht1632_clear_screen();
}

void drv_setup_io() {
	ht1632_setup_io();
}

void drv_init() {
	ht1632_init();
}	

#endif
