/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file ea_ldp8008.h
    \brief Support for LDP-8008 80x08 LED panel
	
*/
#ifndef __ea_ldp8008_h
#define __ea_ldp8008_h

#include "config.h"


#include "pic_utils.h"


/* Include this in your config.h

// - - - - - - - - - - - - - - - - - - - - 
// EA LDP-8008 defines
// - - - - - - - - - - - - - - - - - - - - 

#define ea_ldp8008_displays 1
// For more than one display:
#define ea_ldp8008_display_orientation HORIZONTAL

#define ea_ldp8008_en_port PORTA
#define ea_ldp8008_en_pin  0

#define ea_ldp8008_r_port PORTA
#define ea_ldp8008_r_pin  5

#define ea_ldp8008_g_port PORTA
#define ea_ldp8008_g_pin  5

#define ea_ldp8008_a_port PORTE
#define ea_ldp8008_a_pin  1

#define ea_ldp8008_b_port PORTE
#define ea_ldp8008_b_pin  1

#define ea_ldp8008_c_port PORTE
#define ea_ldp8008_c_pin  1

#define ea_ldp8008_s_port PORTE
#define ea_ldp8008_s_pin  1

#define ea_ldp8008_l_port PORTE
#define ea_ldp8008_l_pin  1

*/


#define ea_ldp8008_setup() ea_ldp8008_setup_io()
void ea_ldp8008_setup_io();
void ea_ldp8008_init();

// - - - - - - - - - - - - - - - - - - - - 
// Checks defines have been made

#ifndef ea_ldp8008_en_port
	#error "You haven't defined ea_ldp8008_en_port in your config.h!"
#endif
#ifndef ea_ldp8008_en_pin
	#error "You haven't defined ea_ldp8008_en_pin in your config.h!"
#endif
#ifndef ea_ldp8008_r_port
	#error "You haven't defined ea_ldp8008_r_port in your config.h!"
#endif
#ifndef ea_ldp8008_r_pin
	#error "You haven't defined ea_ldp8008_r_pin in your config.h!"
#endif
#ifndef ea_ldp8008_g_port
	#error "You haven't defined ea_ldp8008_g_port in your config.h!"
#endif
#ifndef ea_ldp8008_g_pin
	#error "You haven't defined ea_ldp8008_g_pin in your config.h!"
#endif
#ifndef ea_ldp8008_a_port
	#error "You haven't defined ea_ldp8008_a_port in your config.h!"
#endif
#ifndef ea_ldp8008_a_pin
	#error "You haven't defined ea_ldp8008_a_pin in your config.h!"
#endif
#ifndef ea_ldp8008_b_port
	#error "You haven't defined ea_ldp8008_b_port in your config.h!"
#endif
#ifndef ea_ldp8008_b_pin
	#error "You haven't defined ea_ldp8008_b_pin in your config.h!"
#endif
#ifndef ea_ldp8008_c_port
	#error "You haven't defined ea_ldp8008_c_port in your config.h!"
#endif
#ifndef ea_ldp8008_c_pin
	#error "You haven't defined ea_ldp8008_c_pin in your config.h!"
#endif
#ifndef ea_ldp8008_s_port
	#error "You haven't defined ea_ldp8008_s_port in your config.h!"
#endif
#ifndef ea_ldp8008_s_pin
	#error "You haven't defined ea_ldp8008_s_pin in your config.h!"
#endif
#ifndef ea_ldp8008_l_port
	#error "You haven't defined ea_ldp8008_l_port in your config.h!"
#endif
#ifndef ea_ldp8008_l_pin
	#error "You haven't defined ea_ldp8008_l_pin in your config.h!"
#endif


#endif