/*

Copyright (c) 2011, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file ms5511.h
    \brief MS5511 temperature and pressure sensor routines

	A library to communicate with the ms5511 sensor
*/
/*



Put the following into your config.h

// - - - - - - - - - - - - - - - - - - - - 
// pic i2c defines for MS5511
// - - - - - - - - - - - - - - - - - - - - 

#define MS5511_ADDR 0b1110110

#define i2c_scl_port PORTA
#define i2c_sda_port PORTA
#define i2c_scl_pin  0
#define i2c_sda_pin  1

// - - - - - - - - - - - - - - - - - - - - 

  
*/

#include "pic_utils.h"



/**
	\brief Setup ms5511 ports and pins
	
*/
#define ms5511_setup() ms5511_setup_io()
void ms5511_setup_io(void);

void ms5511_init();


uns16 ms5511_get_config(uns8 config_word);
void ms5511_reset();
uns32 ms5511_get_raw_pressure();
uns32 ms5511_get_raw_temp();
void ms5511_calc_temp_and_pressure();
