/*

Copyright (c) 2010, Embedded Adventures, www.embeddedadventures.com
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in the
  documentation and/or other materials provided with the distribution.

- Neither the name of Embedded Adventures nor the names of its contributors
  may be used to endorse or promote products derived from this software
  without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
THE POSSIBILITY OF SUCH DAMAGE.

Contact us at admin@embeddedadventures.com

*/

/*! \file pic_pwm.h
    \brief Software (timer-based) PWM
	
*/

#ifndef __pic_pwm_h
#define __pic_pwm_h


#include "config.h"


#include "pic_utils.h"


// For config.h
/*

// PWM config details
// - - - - - - - - - - - - - -
#define PWM_NUM_PINS 3

#define PWM_PORT_0 PORTB
#define PWM_PIN_0 1

#define PWM_PORT_1 PORTB
#define PWM_PIN_1 4

#define PWM_PORT_2 PORTB
#define PWM_PIN_2 6


// - - - - - - - - - - - - - 

*/

extern uns8 pwm_count;

extern uns8 pwm_level[PWM_NUM_PINS];

// Handle PWM interrupt
void pwm_handle();

// Set the level of a particular pin (8 bit value)
void pwm_set_level(uns8 pwm_item, uns8 level);

// Retrieve the level of a particular pin (8 bit value)
uns8 pwm_get_level(uns8 pwm_item);

// Setup PWM pins as outputs
void pwm_setup_io();

// Transition to another level over time
void pwm_set_transition(uns8 to_level, uns16 steps);

#endif